/*
 * Created on 25-Jul-2003
 *
 */
package jammies.gui;

import javax.swing.*;
import java.io.*;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.event.*;
//import java.beans.*;
//import java.text.*;
import java.util.*;
import java.util.prefs.*;

/**
 * @author john
 *
 */
public class Pad {
	private JFrame frame = new JFrame( "Jammies" );
	private Vector notes = new Vector();
	private String jammieDirName =  ".jammies-notes";
	private File jammieDir = null;
	
	public Pad() {
		initNotes();
		frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
		setupFrame();
		loadPrefs();
		frame.setVisible( true );
		//frame.setExtendedState( JFrame.ICONIFIED );
		for ( int i = 0; i < notes.size(); i++ ) {
			((Note)notes.get( i )).show();
		}
		Runtime.getRuntime().addShutdownHook( new Thread() {
			public void run() {
				writeNotes();
				savePrefs();
			}
		} );
	}

	private void setupFrame() {
		JButton newButton = new JButton( "New Note" );
		newButton.addActionListener( 
			new ActionListener() {
				public void actionPerformed( ActionEvent ae ) {
					newNote();
				}
			}	
		);
		frame.getContentPane().add( newButton );
		frame.pack();
	}
	
	private void savePrefs() {
		Preferences prefs = Preferences.userNodeForPackage( getClass() );
		prefs.putInt( "x", frame.getLocation().x );
		prefs.putInt( "y", frame.getLocation().y );
		prefs.putInt( "exState", frame.getExtendedState() );
		try {
			prefs.flush();
		}
		catch( BackingStoreException bse ) {
		}
	}
	
	private void loadPrefs() {
		Preferences prefs = Preferences.userNodeForPackage( getClass() );
		int x = prefs.getInt( "x", 0 );
		int y = prefs.getInt( "y", 0 );
		frame.setLocation( x, y );
		frame.setExtendedState( prefs.getInt( "exState", Frame.NORMAL ) );
	}
	
	public void newNote() {
		Note note = new Note();
		Dimension size = note.getPreferredSize();
		note.setSize( size.width, size.height );
		addNote( note );
		note.show();
	}
	
	private void addNote( Note note ) {
		notes.add( note );
		note.addWindowListener( new WindowAdapter() {
			public void windowClosing( WindowEvent we ) {
				we.getWindow().dispose();
			}
			
			public void windowClosed( WindowEvent we ) {
				notes.remove( (Note)we.getWindow() );
			}
		} );
	}
	
	private void writeNotes() {
		try {
			File[] files = jammieDir.listFiles();
			for ( int i = 0; i < files.length; i++ ) {
				files[ i ].delete();	
			}
			for ( int i = 0; i < notes.size(); i++ ) {
				writeNote( (Note)notes.elementAt( i ) );	
			}
		}
		catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	private void writeNote( Note note ) {
		int index = notes.indexOf( note );
		try {
			/*File noteFile = new File( jammieDir, "jam-note"+index+".xml" );
			//System.out.println( "Writing note: "+noteFile );
			OutputStream out = new BufferedOutputStream( new FileOutputStream( noteFile ) );
			//System.out.println( "Made output stream" );
			XMLEncoder encoder = new XMLEncoder( out );
			//System.out.println( "Made encoder" );
			encoder.writeObject( note );
			//System.out.println( "Object written" );
			encoder.flush();
			//System.out.println( "encoder fluushed" );
			encoder.close();*/
			//System.out.println( "encoder closed" );
			File noteFile = new File( jammieDir, "jammies"+index+".note" );
			OutputStream out = new BufferedOutputStream( new FileOutputStream( noteFile ) );
			note.write( out );
			out.flush();
			out.close();
			//InputStream in = new BufferedInputStream( new FileInputStream( noteFile ) );
			//note.read( in );
		}
		catch( Exception e ) {
			e.printStackTrace();	
		}
		
	}
	
	private void initNotes() {
		Note.setMainFrame( frame );
		try {
			String userHome = System.getProperty( "user.home" );
			jammieDir = new File( userHome, jammieDirName );
			if ( !jammieDir.exists() && !jammieDir.mkdir() ) {
				System.err.println( "Failed to make "+jammieDirName+" directory" );
				return;
			}
			File[] files = jammieDir.listFiles();
			for ( int i = 0; i < files.length; i++ ) {
				Note note = readNote( files[ i ] );
				if ( note != null )
					addNote( note );
			}
		}
		catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	private Note readNote( File file ) {
		try {
		
			InputStream in = new BufferedInputStream( new FileInputStream( file ) );
			//XMLDecoder decoder = new XMLDecoder( in );
			//Note note = (Note)decoder.readObject();
			//decoder.close();
			Note note = new Note();
			note.read( in );
			return note;
			
		}
		catch( Exception e ) {
			return null;
		}
	}
	
	public static void main(String[] args) {
		new Pad();
	}
}
